>From a06051ce5777d6af937181c96aa9ffcbd48971fd Mon Sep 17 00:00:00 2001
From: Jakub Hrozek <jhrozek@redhat.com>
Date: Fri, 18 Sep 2009 12:35:34 +0200
Subject: [PATCH] Use syslog for logging error conditions in SSSD

This is just a band-aid until ELAPI is fully functional and ready to
use.
---
 server/confdb/confdb.c                     |   36 +++---
 server/confdb/confdb_setup.c               |   24 ++--
 server/db/sysdb.c                          |   66 +++++-----
 server/db/sysdb_ops.c                      |   10 +-
 server/monitor/monitor.c                   |  185 ++++++++++++++-------------
 server/monitor/monitor_sbus.c              |   12 +-
 server/providers/data_provider.c           |   64 ++++++----
 server/providers/data_provider_be.c        |   76 ++++++-----
 server/providers/dp_auth_util.c            |   12 +-
 server/providers/krb5/krb5_auth.c          |    4 +-
 server/providers/ldap/ldap_id.c            |    4 +-
 server/providers/ldap/sdap.c               |   66 +++++-----
 server/providers/ldap/sdap_async.c         |    6 +-
 server/providers/proxy.c                   |   24 ++--
 server/responder/common/responder_common.c |   52 ++++----
 server/responder/common/responder_dp.c     |   24 ++--
 server/responder/nss/nsssrv.c              |   28 +++--
 server/responder/nss/nsssrv_cmd.c          |   52 ++++----
 server/responder/pam/pam_LOCAL_domain.c    |    2 +-
 server/responder/pam/pamsrv.c              |   14 ++-
 server/responder/pam/pamsrv_cache.c        |    2 +-
 server/responder/pam/pamsrv_cmd.c          |    6 +-
 server/responder/pam/pamsrv_dp.c           |   12 +-
 server/sbus/sssd_dbus_common.c             |    8 +-
 server/sbus/sssd_dbus_connection.c         |   10 +-
 server/tools/tools_util.c                  |    3 +
 server/util/debug.c                        |    1 +
 server/util/server.c                       |   34 +++---
 server/util/util.h                         |   16 +++
 29 files changed, 455 insertions(+), 398 deletions(-)

diff --git a/server/confdb/confdb.c b/server/confdb/confdb.c
index 324946d..8cfdf95 100644
--- a/server/confdb/confdb.c
+++ b/server/confdb/confdb.c
@@ -658,15 +658,15 @@ int confdb_init(TALLOC_CTX *mem_ctx,
 
     ret = ldb_set_debug(cdb->ldb, ldb_debug_messages, NULL);
     if (ret != LDB_SUCCESS) {
-        DEBUG(0,("Could not set up debug fn.\n"));
+        SYSLOG_ERROR("Could not set up debug fn.\n");
         talloc_free(cdb);
         return EIO;
     }
 
     ret = ldb_connect(cdb->ldb, confdb_location, 0, NULL);
     if (ret != LDB_SUCCESS) {
-        DEBUG(0, ("Unable to open config database [%s]\n",
-                  confdb_location));
+        SYSLOG_ERROR("Unable to open config database [%s]\n",
+                     confdb_location);
         talloc_free(cdb);
         return EIO;
     }
@@ -739,7 +739,7 @@ static int confdb_get_domain_internal(struct confdb_ctx *cdb,
     }
 
     if (res->count != 1) {
-        DEBUG(0, ("Unknown domain [%s]\n", name));
+        SYSLOG_ERROR("Unknown domain [%s]\n", name);
         ret = ENOENT;
         goto done;
     }
@@ -752,7 +752,7 @@ static int confdb_get_domain_internal(struct confdb_ctx *cdb,
 
     tmp = ldb_msg_find_attr_as_string(res->msgs[0], "cn", NULL);
     if (!tmp) {
-        DEBUG(0, ("Invalid configuration entry, fatal error!\n"));
+        SYSLOG_ERROR("Invalid configuration entry, fatal error!\n");
         ret = EINVAL;
         goto done;
     }
@@ -771,8 +771,8 @@ static int confdb_get_domain_internal(struct confdb_ctx *cdb,
         }
     }
     else {
-        DEBUG(0, ("Domain [%s] does not specify a provider, disabling!\n",
-                  domain->name));
+        SYSLOG_ERROR("Domain [%s] does not specify a provider, disabling!\n",
+                     domain->name);
         ret = EINVAL;
         goto done;
     }
@@ -786,9 +786,9 @@ static int confdb_get_domain_internal(struct confdb_ctx *cdb,
      * superceeded. */
     val = ldb_msg_find_attr_as_int(res->msgs[0], "enumerate", 0);
     if (val > 0) { /* ok there was a number in here */
-        DEBUG(0, ("Warning: enumeration parameter in %s still uses integers! "
-                  "Enumeration is now a boolean and takes true/false values. "
-                  "Interpreting as true\n", domain->name));
+        SYSLOG_ERROR("Warning: enumeration parameter in %s still uses integers! "
+                     "Enumeration is now a boolean and takes true/false values. "
+                     "Interpreting as true\n", domain->name);
         domain->enumerate = true;
     } else { /* assume the new format */
         if (ldb_msg_find_attr_as_bool(res->msgs[0], "enumerate", 0)) {
@@ -814,7 +814,7 @@ static int confdb_get_domain_internal(struct confdb_ctx *cdb,
     ret = get_entry_as_uint32(res->msgs[0], &domain->id_min,
                               "minId", SSSD_MIN_ID);
     if (ret != EOK) {
-        DEBUG(0, ("Invalid value for minId\n"));
+        SYSLOG_ERROR("Invalid value for minId\n");
         ret = EINVAL;
         goto done;
     }
@@ -822,13 +822,13 @@ static int confdb_get_domain_internal(struct confdb_ctx *cdb,
     ret = get_entry_as_uint32(res->msgs[0], &domain->id_max,
                               "maxId", 0);
     if (ret != EOK) {
-        DEBUG(0, ("Invalid value for maxId\n"));
+        SYSLOG_ERROR("Invalid value for maxId\n");
         ret = EINVAL;
         goto done;
     }
 
     if (domain->id_max && (domain->id_max < domain->id_min)) {
-        DEBUG(0, ("Invalid domain range\n"));
+        SYSLOG_ERROR("Invalid domain range\n");
         ret = EINVAL;
         goto done;
     }
@@ -869,19 +869,19 @@ int confdb_get_domains(struct confdb_ctx *cdb,
     ret = confdb_get_string_as_list(cdb, tmp_ctx,
                                     CONFDB_DOMAINS_PATH, "domains", &domlist);
     if (ret == ENOENT) {
-        DEBUG(0, ("No domains configured, fatal error!\n"));
+        SYSLOG_ERROR("No domains configured, fatal error!\n");
         goto done;
     }
     if (ret != EOK ) {
-        DEBUG(0, ("Fatal error retrieving domains list!\n"));
+        SYSLOG_ERROR("Fatal error retrieving domains list!\n");
         goto done;
     }
 
     for (i = 0; domlist[i]; i++) {
         ret = confdb_get_domain_internal(cdb, cdb, domlist[i], &domain);
         if (ret) {
-            DEBUG(0, ("Error (%d [%s]) retrieving domain [%s], skipping!\n",
-                      ret, strerror(ret), domlist[i]));
+            SYSLOG_ERROR("Error (%d [%s]) retrieving domain [%s], skipping!\n",
+                         ret, strerror(ret), domlist[i]);
             ret = EOK;
             continue;
         }
@@ -896,7 +896,7 @@ int confdb_get_domains(struct confdb_ctx *cdb,
     }
 
     if (cdb->doms == NULL) {
-        DEBUG(0, ("No properly configured domains, fatal error!\n"));
+        SYSLOG_ERROR("No properly configured domains, fatal error!\n");
         ret = ENOENT;
         goto done;
     }
diff --git a/server/confdb/confdb_setup.c b/server/confdb/confdb_setup.c
index 00bba7f..3c2cb71 100644
--- a/server/confdb/confdb_setup.c
+++ b/server/confdb/confdb_setup.c
@@ -110,8 +110,8 @@ int confdb_create_base(struct confdb_ctx *cdb)
     while ((ldif = ldb_ldif_read_string(cdb->ldb, &base_ldif))) {
         ret = ldb_add(cdb->ldb, ldif->msg);
         if (ret != LDB_SUCCESS) {
-            DEBUG(0, ("Failed to initialize DB (%d,[%s]), aborting!\n",
-                      ret, ldb_errstring(cdb->ldb)));
+            SYSLOG_ERROR("Failed to initialize DB (%d,[%s]), aborting!\n",
+                         ret, ldb_errstring(cdb->ldb));
             return EIO;
         }
         ldb_ldif_read_free(cdb->ldb, ldif);
@@ -279,13 +279,13 @@ int confdb_init_db(const char *config_file, struct confdb_ctx *cdb)
     /* ok, first of all stat conf file */
     ret = stat(config_file, &cstat);
     if (ret != 0) {
-        DEBUG(0, ("Unable to stat config file [%s]! (%d [%s])\n",
-                  config_file, errno, strerror(errno)));
+        SYSLOG_ERROR("Unable to stat config file [%s]! (%d [%s])\n",
+                     config_file, errno, strerror(errno));
         return errno;
     }
     ret = snprintf(timestr, 21, "%llu", (long long unsigned)cstat.st_mtime);
     if (ret <= 0 || ret >= 21) {
-        DEBUG(0, ("Failed to convert time_t to string ??\n"));
+        SYSLOG_ERROR("Failed to convert time_t to string ??\n");
         return errno ? errno: EFAULT;
     }
 
@@ -303,7 +303,7 @@ int confdb_init_db(const char *config_file, struct confdb_ctx *cdb)
     /* Set up a transaction to replace the configuration */
     ret = ldb_transaction_start(cdb->ldb);
     if (ret != LDB_SUCCESS) {
-        DEBUG(0, ("Failed to start a transaction for updating the configuration\n"));
+        SYSLOG_ERROR("Failed to start a transaction for updating the configuration\n");
         talloc_free(tmp_ctx);
         return sysdb_error_to_errno(ret);
     }
@@ -311,7 +311,7 @@ int confdb_init_db(const char *config_file, struct confdb_ctx *cdb)
     /* Purge existing database */
     ret = confdb_purge(cdb);
     if (ret != EOK) {
-        DEBUG(0, ("Could not purge existing configuration\n"));
+        SYSLOG_ERROR("Could not purge existing configuration\n");
         goto done;
     }
 
@@ -319,8 +319,8 @@ int confdb_init_db(const char *config_file, struct confdb_ctx *cdb)
     ret = config_from_file("sssd", config_file, &sssd_config,
                            INI_STOP_ON_ANY, &error_list);
     if (ret != EOK) {
-        DEBUG(0, ("Parse error reading configuration file [%s]\n",
-                  config_file));
+        SYSLOG_ERROR("Parse error reading configuration file [%s]\n",
+                     config_file);
         print_file_parsing_errors(stderr, error_list);
         free_ini_config_errors(error_list);
         free_ini_config(sssd_config);
@@ -330,7 +330,7 @@ int confdb_init_db(const char *config_file, struct confdb_ctx *cdb)
     ret = confdb_create_ldif(tmp_ctx, sssd_config, &config_ldif);
     free_ini_config(sssd_config);
     if (ret != EOK) {
-        DEBUG(0, ("Could not create LDIF for confdb\n"));
+        SYSLOG_ERROR("Could not create LDIF for confdb\n");
         goto done;
     }
 
@@ -340,8 +340,8 @@ int confdb_init_db(const char *config_file, struct confdb_ctx *cdb)
     while ((ldif = ldb_ldif_read_string(cdb->ldb, (const char **)&config_ldif))) {
         ret = ldb_add(cdb->ldb, ldif->msg);
         if (ret != LDB_SUCCESS) {
-            DEBUG(0, ("Failed to initialize DB (%d,[%s]), aborting!\n",
-                      ret, ldb_errstring(cdb->ldb)));
+            SYSLOG_ERROR("Failed to initialize DB (%d,[%s]), aborting!\n",
+                         ret, ldb_errstring(cdb->ldb));
             ret = EIO;
             goto done;
         }
diff --git a/server/db/sysdb.c b/server/db/sysdb.c
index 87d0de9..b63a5a4 100644
--- a/server/db/sysdb.c
+++ b/server/db/sysdb.c
@@ -808,16 +808,16 @@ static int sysdb_upgrade_02(struct confdb_ctx *cdb,
         }
 
         if (strcmp(version, SYSDB_VERSION_0_2) != 0) {
-            DEBUG(0,("Wrong DB version [%s],"
-                     " expected [%s] for this upgrade!\n",
-                     version, SYSDB_VERSION));
+            SYSLOG_ERROR("Wrong DB version [%s],"
+                         " expected [%s] for this upgrade!\n",
+                         version, SYSDB_VERSION);
             ret = EINVAL;
             goto done;
         }
     }
     talloc_zfree(res);
 
-    DEBUG(0, ("UPGRADING DB TO VERSION %s\n", SYSDB_VERSION_0_3));
+    SYSLOG_NOTICE("UPGRADING DB TO VERSION %s\n", SYSDB_VERSION_0_3);
 
     /* ldb uses posix locks,
      * posix is stupid and kills all locks when you close *any* file
@@ -924,18 +924,18 @@ static int sysdb_upgrade_02(struct confdb_ctx *cdb,
 
             ret = ldb_add(ctx->ldb, msg);
             if (ret != LDB_SUCCESS) {
-                DEBUG(0, ("WARNING: Could not add entry %s,"
-                          " to new ldb file! (%d [%s])\n",
-                          ldb_dn_get_linearized(msg->dn),
-                          ret, ldb_errstring(ctx->ldb)));
+                SYSLOG_ERROR("WARNING: Could not add entry %s,"
+                             " to new ldb file! (%d [%s])\n",
+                             ldb_dn_get_linearized(msg->dn),
+                             ret, ldb_errstring(ctx->ldb));
             }
 
             ret = ldb_delete(local->ldb, msg->dn);
             if (ret != LDB_SUCCESS) {
-                DEBUG(0, ("WARNING: Could not remove entry %s,"
-                          " from old ldb file! (%d [%s])\n",
-                          ldb_dn_get_linearized(msg->dn),
-                          ret, ldb_errstring(local->ldb)));
+                SYSLOG_ERROR("WARNING: Could not remove entry %s,"
+                             " from old ldb file! (%d [%s])\n",
+                             ldb_dn_get_linearized(msg->dn),
+                             ret, ldb_errstring(local->ldb));
             }
         }
 
@@ -1129,8 +1129,8 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
             }
 
             if (!allow_upgrade) {
-                DEBUG(0, ("Wrong DB version (got %s expected %s)\n",
-                          version, SYSDB_VERSION));
+                SYSLOG_ERROR("Wrong DB version (got %s expected %s)\n",
+                             version, SYSDB_VERSION);
                 ret = EINVAL;
                 goto done;
             }
@@ -1144,8 +1144,8 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
             if (strcmp(version, SYSDB_VERSION_0_2) == 0) {
                 /* if this is not local we have a big problem */
                 if (strcasecmp(domain->provider, "local") != 0) {
-                    DEBUG(0, ("Fatal: providers other than 'local'"
-                              " shouldn't present v0.2, db corrupted?\n"));
+                    SYSLOG_ERROR("Fatal: providers other than 'local'"
+                                 " shouldn't present v0.2, db corrupted?\n");
                     ret = EFAULT;
                     goto done;
                 }
@@ -1155,9 +1155,9 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
                 if (need_02_upgrade) {
                     *need_02_upgrade = true;
                 } else {
-                    DEBUG(0, ("DB file seem to need an upgrade,"
-                              " but upgrade flag is not provided,"
-                              " db corrupted?\n"));
+                    SYSLOG_ERROR("DB file seem to need an upgrade,"
+                                 " but upgrade flag is not provided,"
+                                 " db corrupted?\n");
                     ret = EFAULT;
                     goto done;
                 }
@@ -1168,8 +1168,8 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
 
         }
 
-        DEBUG(0,("Unknown DB version [%s], expected [%s] for domain %s!\n",
-                 version?version:"not found", SYSDB_VERSION, domain->name));
+        SYSLOG_ERROR("Unknown DB version [%s], expected [%s] for domain %s!\n",
+                     version?version:"not found", SYSDB_VERSION, domain->name);
         ret = EINVAL;
         goto done;
     }
@@ -1180,8 +1180,8 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
     while ((ldif = ldb_ldif_read_string(ctx->ldb, &base_ldif))) {
         ret = ldb_add(ctx->ldb, ldif->msg);
         if (ret != LDB_SUCCESS) {
-            DEBUG(0, ("Failed to initialize DB (%d, [%s]) for domain %s!",
-                      ret, ldb_errstring(ctx->ldb), domain->name));
+            SYSLOG_ERROR("Failed to initialize DB (%d, [%s]) for domain %s!",
+                         ret, ldb_errstring(ctx->ldb), domain->name);
             ret = EIO;
             goto done;
         }
@@ -1208,8 +1208,8 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
     /* do a synchronous add */
     ret = ldb_add(ctx->ldb, msg);
     if (ret != LDB_SUCCESS) {
-        DEBUG(0, ("Failed to initialize DB (%d, [%s]) for domain %s!",
-                  ret, ldb_errstring(ctx->ldb), domain->name));
+        SYSLOG_ERROR("Failed to initialize DB (%d, [%s]) for domain %s!",
+                     ret, ldb_errstring(ctx->ldb), domain->name);
         ret = EIO;
         goto done;
     }
@@ -1236,8 +1236,8 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
     /* do a synchronous add */
     ret = ldb_add(ctx->ldb, msg);
     if (ret != LDB_SUCCESS) {
-        DEBUG(0, ("Failed to initialize DB (%d, [%s]) for domain %s!",
-                  ret, ldb_errstring(ctx->ldb), domain->name));
+        SYSLOG_ERROR("Failed to initialize DB (%d, [%s]) for domain %s!",
+                     ret, ldb_errstring(ctx->ldb), domain->name);
         ret = EIO;
         goto done;
     }
@@ -1264,8 +1264,8 @@ static int sysdb_domain_init_internal(TALLOC_CTX *mem_ctx,
     /* do a synchronous add */
     ret = ldb_add(ctx->ldb, msg);
     if (ret != LDB_SUCCESS) {
-        DEBUG(0, ("Failed to initialize DB (%d, [%s]) for domain %s!",
-                  ret, ldb_errstring(ctx->ldb), domain->name));
+        SYSLOG_ERROR("Failed to initialize DB (%d, [%s]) for domain %s!",
+                     ret, ldb_errstring(ctx->ldb), domain->name);
         ret = EIO;
         goto done;
     }
@@ -1360,10 +1360,10 @@ int sysdb_init(TALLOC_CTX *mem_ctx,
 
         ret = sysdb_upgrade_02(cdb, ev, ctx, ctx_list);
         if (ret != EOK) {
-            DEBUG(0, ("FATAL: Upgrade form db version %d failed!\n",
-                      SYSDB_VERSION_0_2));
-            DEBUG(0, ("You can find a backup of the database here: %s\n",
-                      backup_file));
+            SYSLOG_ERROR("FATAL: Upgrade form db version %s failed!\n",
+                         SYSDB_VERSION_0_2);
+            SYSLOG_ERROR("You can find a backup of the database "
+                         "in file named %s.bak", ctx->ldb_file);
             talloc_zfree(ctx_list);
             return ret;
         }
diff --git a/server/db/sysdb_ops.c b/server/db/sysdb_ops.c
index 3a53c9e..c0a4832 100644
--- a/server/db/sysdb_ops.c
+++ b/server/db/sysdb_ops.c
@@ -1352,8 +1352,8 @@ static void sysdb_get_new_id_base(struct tevent_req *subreq)
 
         if ((state->domain->id_max != 0) &&
             (state->new_id > state->domain->id_max)) {
-            DEBUG(0, ("Failed to allocate new id, out of range (%u/%u)\n",
-                      state->new_id, state->domain->id_max));
+            SYSLOG_ERROR("Failed to allocate new id, out of range (%u/%u)\n",
+                         state->new_id, state->domain->id_max);
             tevent_req_error(req, ERANGE);
             return;
         }
@@ -1484,8 +1484,8 @@ static void sysdb_get_new_id_verify(struct tevent_req *subreq)
         /* check again we are not falling out of range */
         if ((state->domain->id_max != 0) &&
             (state->new_id > state->domain->id_max)) {
-            DEBUG(0, ("Failed to allocate new id, out of range (%u/%u)\n",
-                      state->new_id, state->domain->id_max));
+            SYSLOG_ERROR("Failed to allocate new id, out of range (%u/%u)\n",
+                         state->new_id, state->domain->id_max);
             tevent_req_error(req, ERANGE);
             return;
         }
@@ -1733,7 +1733,7 @@ struct tevent_req *sysdb_add_user_send(TALLOC_CTX *mem_ctx,
 
     if (domain->mpg) {
         if (gid != 0) {
-            DEBUG(0, ("Cannot add user with arbitrary GID in MPG domain!\n"));
+            SYSLOG_ERROR("Cannot add user with arbitrary GID in MPG domain!\n");
             ERROR_OUT(ret, EINVAL, fail);
         }
         state->gid = state->uid;
